#!/usr/bin/perl

# PageCreator
#  simply make webpages with a template
#  version 0.51
#
# This program is a small fraction of the eMediaAdmin software
#      which can be ordered from http://www.reedmedia.net
#      eMediaAdmin is a powerful, webased system for uploading and 
#      managing newspapers and magazine websites.
#
# Sept. 3, 1999
# updated: Oct. 12, 1999
#
# Copyright (c) 1999 Jeremy C. Reed. All Rights Reserved.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the Artistic license.

$baseurl = '';
$cgi_url = 'index.cgi';
$basepath = '';
$template = 'template.html';

$new_filename = 'webpage.html';
$image_fname = 'image.';   ## extention will be added

$tab = '&nbsp; &nbsp; &nbsp; ';
$bullet_char = '&#149;'; ## works under linux and Win98
$em_dash = '--';   ## html &emdash; isn't always supported
$head_font_info = 'color=#30434A face="Arial, Helvetica, sans-serif" size=5';
$related_font_info = 'color=#496674 face="Arial, Helvetica, sans-serif"';
$date_font_info = 'size=2 color=#505050';
$author_font_info = 'color=#505050';

&main_routine;

sub main_routine {

# begin html output
  &begin_html;

# Get CGI Form information
  &parse_form;
  &get_timedate;

  if ($FORM{'do'} eq 'add_story') {
    if ($FORM{'headline'}) {
      &add_story;
    }
    else { &error ("Must have a HEADLINE<p> Press <b>BACK</b>");}
  }
  else {
    &adv_upload;
  }

  &end_html;

} # main routine

######################
# add story and update sections

sub add_story {

  $FORM{'text'} = &convert_chars($FORM{'text'});
  $FORM{'headline'} = &convert_chars($FORM{'headline'});
  $FORM{'short'} = &convert_chars($FORM{'short'});


# $FORM{'story_fname'}
  if ($FORM{'use_image'}) {  ## use image already on server
    $image_fname = $FORM{'use_image'};
  }
  elsif (($FORM{'FILE_NAME'}) && ($FORM{'FILE_CONTENT'})) {
    $image_fname = "$image_fname$FORM{'imagetype'}";
    &save_uploaded_file;
    print "Image uploaded: <a href=$baseurl$image_fname>$image_fname</a><br>\n";
  }
  else { ## no image
    $image_fname = '';
  }

  $make = "$basepath$new_filename";

  if ($FORM{'has_html'} ne "on") { ## convert TABS/etc to HTML
   $FORM{'text'} =~ s/\t/$tab/g;
   $FORM{'text'} =~ s/\</&lt;/g;
   $FORM{'text'} =~ s/\>/&gt;/g;
   $FORM{'text'} =~ s/\"/&quot;/g;
  }

  if ($FORM{'convert_spaces'} eq "on") {  ## convert spaces to tab
    $FORM{'text'} =~ s/   /$tab/g;
  }

  $FORM{'text'} =~ s/\r//g;  ## get rid of carriage returns
  if ($FORM{'convert'} eq "single") { ## convert single LF to HTML
    $FORM{'text'} =~ s/\n/<p>\n/g;
  }

  if ($FORM{'convert'} eq "double") { ## convert double lf or cr to HTML
    $FORM{'text'} =~ s/\n\n/<p>\n/g;
  }

  ## new routine to wordwrap long lines!
  ## do this after all other formatting!
  @words = split (' ', $FORM{'text'});
  $FORM{'text'} = '';
  foreach $word (@words) {
    $FORM{'text'} .= "$word ";
    $line_length += (length(word) + 1);
    if ($line_length > 65) {
      $FORM{'text'} .= "\n";
      $line_length = 0;
    } 
  }

  ## make new story page
  &make_story ($make, $template);
  print "Story created: <a href=$baseurl$new_filename\>$new_filename</a><br>\n";

} #add story

###############
# Get time and date

sub get_timedate {
  local ($current_time);

  $current_time = (time + $time_difference);

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
    localtime($current_time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("January","February","March","April","May","June","July","August","September","October","November","December");

   $date = "$month/$mday/$year";

   $year = $year + 1900;

   $long_date =
       "$months[$mon] $mday, $year $hour\:$min\:$sec $timezone";

} # get time and date

#####################
# Make story HTML from TEMPLATES routine

sub make_story {

# read template
  open(TEMPLATE, "$_[1]") || error ("Couldn't read $_[1]", 1);
  @html = <TEMPLATE>;
  close(TEMPLATE);

# open or create updated html
  open(NEWFILE,">$_[0]") || error ("Couldn't create $_[0]", 2);
  print NEWFILE "<!-- created by pagecreator -->\n";

#make updates and output
  foreach $html_line (@html) {
    
    if ($html_line =~ /<\/title>/i) {

      $lookfor = "<\/title>";
      $replace = ": $FORM{'headline'}<\/title>";
      $html_line =~ s/$lookfor/$replace/i;
    }

    if ($html_line =~ /<!-- insert url/) {

      $lookfor = "<!-- insert url -->";
      $replace = "$new_filename";
      $html_line =~ s/$lookfor/$replace/;
    }

    if ($html_line =~ /<!-- insert timedate/) {
      $lookfor = "<!-- insert timedate -->";
      $replace = "$long_date";
      $html_line =~ s/$lookfor/$replace/;
    }
    if ($html_line =~ /<!-- insert thestory/) {
      
      print NEWFILE <<story_html;
<font $head_font_info>
<b>
<!-- EA START_HEAD -->
$FORM{'headline'}
<!-- EA END_HEAD -->
</b>
</font><br>
story_html

      if ($FORM{'short'}) {
        print NEWFILE <<story2_html;
<font $short_font_info>
<!-- EA START_SHORT -->
$FORM{'short'}
<!-- EA END_SHORT -->
</font><br>
story2_html
      }
      print NEWFILE "<br>\n";
      if ($FORM{'author'}) {
        print NEWFILE "<font $author_font_info>";
        if ($FORM{'authorlink'}) {
          if ($FORM{'authorlink'} =~ /\@/) {
            print NEWFILE "<a href=\"mailto:$FORM{'authorlink'}\">";
          } else {
            print NEWFILE "<a href=\"$FORM{'authorlink'}\">";
          }
          print NEWFILE "$FORM{'author'}</a><br>\n";
          print NEWFILE "<!-- EA AUTHORLINK::$FORM{'authorlink'} -->\n";
        } else {
          print NEWFILE "$FORM{'author'}<br>\n";
        }  
        if ($FORM{'authortitle'}) {
          print NEWFILE "<i>$FORM{'authortitle'}</i><br>\n";
          print NEWFILE "<!-- EA TITLE::$FORM{'authortitle'} -->\n";

        }
        print NEWFILE "</font><br>\n";
  
        print NEWFILE "<!-- EA AUTHOR::$FORM{'author'} -->\n";

      }

      if (($image_fname) && ($FORM{'place_image'} eq 'top')) {
        if ($FORM{'align_image'} eq "center") {
          print NEWFILE "<center>"; 
        }
        if (($FORM{'cutline'}) || ($FORM{'caption'})) {
          print NEWFILE "<table bgcolor=#a0a0a0 width=100 align=$FORM{'align_image'}><tr><td>\n";
        }
        print NEWFILE "<img align=$FORM{'align_image'} src=\"$baseurl$image_fname\">\n";
        if ($FORM{'cutline'}) {
          print NEWFILE "</td></tr><tr><td align=right>\n<font size=1>";
          print NEWFILE "$FORM{'cutline'}\n</font>";
        }
        if ($FORM{'caption'}) {
          print NEWFILE "</td></tr><tr><td>\n<b>$FORM{'caption'}</b>";
        }
        if (($FORM{'cutline'}) || ($FORM{'caption'})) {
          print NEWFILE "</td>\n</tr></table>\n";
        }
        if ($FORM{'align_image'} eq "center") {
          print NEWFILE "</center>"; 
        }
      } ## if top image #1

      print NEWFILE "<!-- EA START_TEXT -->\n";
      print NEWFILE "$FORM{'text'}";
      print NEWFILE "\n<!-- EA END_TEXT -->\n";

#      print NEWFILE "<!-- EA IMAGE_PLACE::$FORM{'place_image'} -->\n";
#      print NEWFILE "<!-- EA IMAGE_ALIGN::$FORM{'align_image'} -->\n";
      print NEWFILE "<!-- EA IMAGE::$image_fname -->\n";

      if (($image_fname) && ($FORM{'place_image'} eq 'bottom')) { 
        if ($FORM{'align_image'} eq "center") {
          print NEWFILE "<center>"; 
        }
        if (($FORM{'cutline'}) || ($FORM{'caption'})) {
          print NEWFILE "<table bgcolor=#a0a0a0 width=100 align=$FORM{'align_image'}><tr><td>\n";
        }
        print NEWFILE "<img align=$FORM{'align_image'} src=\"$baseurl$image_fname\">\n";
        if ($FORM{'cutline'}) {
          print NEWFILE "</td></tr><tr><td align=right>\n<font size=1>";
          print NEWFILE "$FORM{'cutline'}\n</font>";
        }
        if ($FORM{'caption'}) {
          print NEWFILE "</td></tr><tr><td>\n<b>$FORM{'caption'}</b>";
        }
        if (($FORM{'cutline'}) || ($FORM{'caption'})) {
          print NEWFILE "</td>\n</tr></table>\n";
        }
        if ($FORM{'align_image'} eq "center") {
          print NEWFILE "</center>"; 
        }
      } ## if bottom image #1

      if ($FORM{'add_links'} eq "on") {
        print NEWFILE "<p>\n<!-- EA LINKS_START -->\n<font $related_font_info>LINKS";

        print NEWFILE "<br>\n<font size=-1>\n";

        $temp_title = $FORM{'link_title1'};
        $templink = $FORM{'link_url1'};
        if (($temp_title) && ($templink)) {
          print NEWFILE "<a href=\"$templink\">$temp_title</a><br>\n";
        }
        $temp_title = $FORM{'link_title2'};
        $templink = $FORM{'link_url2'};
        if (($temp_title) && ($templink)) {
          print NEWFILE "<a href=\"$templink\">$temp_title</a><br>\n";
        }
        $temp_title = $FORM{'link_title3'};
        $templink = $FORM{'link_url3'};
        if (($temp_title) && ($templink)) {
          print NEWFILE "<a href=\"$templink\">$temp_title</a><br>\n";
        }
        print NEWFILE "<\/font><\/font>\n";
        print NEWFILE "<!-- EA LINKS_END -->\n";
      }
    }

    print NEWFILE "$html_line";

  }

  close (NEWFILE);

}    # make_story

#####################
# html form for advanced upload of story

sub adv_upload {

print <<form_html;

<form action="$cgi_url" method=post ENCTYPE="multipart/form-data">

<h2>Headline</h2>

<i>Insert headline/title for webpage</i><br>
<textarea name="headline" rows=2 cols=50>$headline
</textarea>
<p>

<h2>Sub-head</h2>
<i>Insert subhead</i><br>
<textarea name="short" rows=2 cols=50>$short
</textarea>

<p>
<h2>By-line/Author<i>(optional)</i></h2>
Name: <input type=text name=author value="$author"><br>
Title: <input type=text name=authortitle value="$authortitle"><br>
Link or e-mail: <input type=text name=authorlink value="$authorlink"><br>
<p>

<hr>
<a name=story></a>
<h2>Story/Article Text</h2>
<input type=radio name="convert" checked value="single">Convert single
linefeed/carriage return to newline
<input type="radio" name="convert" value="double">Convert double lf/br
<input type="radio" name="convert" value="none">No LF/CR conversion
<br>
<input type="checkbox" name="has_html">Contains HTML

<input type=checkbox name="convert_spaces">Convert multiple spaces
to tab/indent<p>
<i>Enter ("Paste") the article or story</i><br>
<textarea name="text" rows=20 cols=75>$text
</textarea>
<p>

<b>Image</b><br>
Image to upload: <input name="upload_file" type="file"><br>
File type: 
<input type=radio name=imagetype checked value="jpg">jpg &nbsp;
<input type=radio name=imagetype value="gif">gif<br>
<i>(image filename will be renamed, unless you enter filename below)</i>
<p>

Or, use image (enter filename): <input name="use_image"><br>
<p>
Align image:<br>
&nbsp; &nbsp; <input type=radio name="align_image" value="left">Left
&nbsp; &nbsp; <input type=radio name="align_image" value="center">Center
&nbsp; &nbsp; <input type=radio name="align_image" value="right"
checked>Right
<br>
&nbsp; &nbsp; <input type=radio name="place_image" value="top" checked>Top
&nbsp; &nbsp; <input type=radio name="place_image" value="bottom">Bottom
<p>

Cutline: <input type=text name=cutline
value="$cutline"><br>
Caption:<br>
<textarea name="caption" rows=2 cols=35>$caption
</textarea>
<p>

<input type=checkbox name=add_links>Add <B>Related Webpage(s)</b>:<br>
&nbsp; &nbsp; Title: <input name=link_title1 size=35><br>
&nbsp; &nbsp; URL: <input name=link_url1 value="http://" size=35><br>
&nbsp; &nbsp; Title: <input name=link_title2 size=35><br>
&nbsp; &nbsp; URL: <input name=link_url2 value="http://" size=35><br>
&nbsp; &nbsp; Title: <input name=link_title3 size=35><br>
&nbsp; &nbsp; URL: <input name=link_url3 value="http://" size=35><br>
<br>

<p>
<input type="hidden" name="do" value="add_story">
<input type="submit" value="Make Webpage">
</form><p>

form_html

} ## advanced upload form


#####################
# Output beginning HTML

sub begin_html {

  print <<htmldata;
Content-type: text/html


<html><head><title>PageCreator -- quickly make a web page!</title></head>
<body bgcolor=#ffffff>

<table width=100% cellpadding=0 cellspacing=0 bgcolor=#cccccc>
<tr><td>
&nbsp; &nbsp; 
<font face="helvetica, ms sans serif, arial" size=5
color=#003366>PageCreator</font>
</td>
</tr>
</table>
<br>

htmldata

} ## begin html


#####################
# Output ending HTML

sub end_html {
  print <<htmldata;

<hr size=1>
</body></html>

htmldata
}#end html


##############
## 
sub save_uploaded_file {

  local ($temp_size);

  open(OUTPUT,">$basepath$image_fname");
  print OUTPUT $FORM{'FILE_CONTENT'};
  close(OUTPUT);
 
  chmod(0755,"$basepath$image_fname");
  print "File saved to: $basepath$image_fname<br>\n";
  $temp_size = length($FORM{'FILE_CONTENT'});
  print " &nbsp; &nbsp; (Size: $temp_size)<br>\n";

} # save_uploaded_file

#####################
# Output Error problems

sub error {
  print "<b><font color=red>ERROR: $_[0]</b><p>\n</font>\n"; 

  &end_html;
  exit;
} ## shows error message

#####################

sub parse_form {

    local ($i, $loc, $key, $val, $buffer);
    local($f,$header, $header_body, $len, $buf);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {
      $buffer = $ENV{'QUERY_STRING'};
    }
    else {
      # Need to read TILL we got all bytes
      $len = 0;
      $buffer = '';
      while( $len != $ENV{'CONTENT_LENGTH'} ) {
          $buf = '';
          $len += sysread(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
          $buffer .= $buf;
        }
    }

   # conform to RFC1867 for upload specific
    if ( $ENV{'CONTENT_TYPE'} =~ /multipart\/form-data; boundary=(.+)$/ ) {
      $boundary = '--'.$1;  # please refer to RFC1867
      @list = split(/$boundary/, $buffer);

      # parse trailer
      foreach $i (@list) {

         if ($i =~
      /Content-Disposition: form-data; name="upload_file";/) {
           $header_body = $i;
           $header_body =~ /\r\n\r\n|\n\n/; # separate header and body
           $header = $`;        # front part
           $body   = $';        # rear part
           $body =~ s/\r\n$//;  # the last \r\n was put in by Netscape

           $FORM{'FILE_CONTENT'} = $body;

           # parse header
           $header =~ /filename=\"(.+)\"/;
           $FORM{'FILE_NAME'} = $1;
           $FORM{'FILE_NAME'} =~ s/\"//g; # remove "s
           # make sure no space(include \n, \r..) in the file name
           $FORM{'FILE_NAME'} =~ s/\s//g;
           # keep after /
           $FORM{'FILE_NAME'} =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/\1/;
           $FORM{'FILE_NAME'} =~ 
              s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
           $FORM{'FILE_NAME'} =~ s/\"//g; # remove "s
           # make sure no space(include \n,\r..) in the file name
           $FORM{'FILE_NAME'} =~ s/\s//g;

         } # uploaded file
         else {
           $header = $i;
           $header =~ s/^.+name=$//;
           $header =~ /\"(\w+)\"\r\n\r\n/;
           $key = $1;
           if (($key) && ($boundary !~ $key)) { ## not blank or $boundary
             $FORM{$key} = $';
             $FORM{$key} =~ s/(..)\r\n$/$1/;
             if ($FORM{$key} eq "\r\n") { # if empty
               $FORM{$key} = "";
             }

           } ## not a blank $key or $boundary
         }   
      }

    }
    else { # not RFC1867

      # Split the name-value pairs
      @pairs = split(/&/, $buffer);

      foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        # Un-Webify plus signs and %-encoding
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        $FORM{$name} = $value;
      }

    }
} # parse_form


################
## convert special characters
sub convert_chars {

### should do it like this
## local ($char);
## @special_chars = ('\HB3', '\HB2');
## %special_chars = ('\HB3', '\"',
##                   '\HB2', '\"');
## foreach $char (@special_chars) {
##   $_[0] =~ s/$char/$special_chars{$char}/g;
## }

# funky Macintosh fonts!
  $temp_ch = pack("c", hex("B3"));
  $_[0] =~ s/$temp_ch/\"/g;
  $temp_ch = pack("c", hex("B2"));
  $_[0] =~ s/$temp_ch/\"/g;
  $temp_ch = pack("c", hex("B9"));
  $_[0] =~ s/$temp_ch/\'/g;
  $temp_ch = pack("c", hex("8C"));
  $_[0] =~ s/$temp_ch/\'/g;
  $temp_ch = pack("c", hex("8B"));
  $_[0] =~ s/$temp_ch/$em_dash/g; ## need to pick some long dash!
  $temp_ch = pack("c", hex("92"));  ## IBM/MS font ??
  $_[0] =~ s/$temp_ch/\'/g;

## more MaCINTOSH fonts
  $temp_ch = pack("c", hex("D2"));  ## start double
  $_[0] =~ s/$temp_ch/\"/g;
  $temp_ch = pack("c", hex("D3"));  ## end double quote
  $_[0] =~ s/$temp_ch/\"/g;
  $temp_ch = pack("c", hex("D5"));
  $_[0] =~ s/$temp_ch/\'/g;
  
  $temp_ch = pack("c", hex("A5"));
  $_[0] =~ s/$temp_ch/$bullet_char/g;

#  $_[0] =~ s/\139/$em_dash/g; ## need to pick some long dash!
#  $_[0] =~ s/[\212|\185|\140|\146|\213]/\'/g;
#  $_[0] =~ s/[\211|\210|\178|\179]/\"/g;

  return $_[0];

} # convert characters

